!= Υȴ夲
!
!= Mars Dust Lifting!
!
! Authors::   OGIHARA Hirotaka
! Version::   $Id: Mars_dust_lifting.f90,v 4.0 2017-9-4 15:46:44 Ogihara Exp $ 
! Tag Name::  $Name: dcpam5-20160612$
! Copyright:: Copyright (C) GFD Dennou Club, 2012-2016. All rights reserved.
! License::   See COPYRIGHT[link:../../../COPYRIGHT]
!

module mars_dust_lifting
  !
  != Υȴ夲
  !
  != Mars Dust Lifting
  !
  ! <b>Note that Japanese and English are described in parallel.</b>
  !
  ! Kahre et al (2006) ˴ŤƲΥȴ夲Ψ׻. 
  !: 2013/03/06  ˴Ǵ夬ʤ褦ˤ
  !      2013/03/14  ޤ˴Ǵ夬äƤΤǴ˴夬ʤ褦ˤ
  !      2013/09/03  Ūʷѹ
  !      2013/12/24  ȥǥӥɲ
  !      2013/12/27  DTH Ͱʲ򴬤夲ʤ褦ˤ
  !      2014/04/08  ؾü heatflux <=0 ΤȤˤ
  !      2014/04/08  ؾü turkinene <= 0.5 Ǥ褦ˤ뤳Ȥˤ(Newman)
  !      2014/04/08  ؾüȽλݤ뤳Ȥˤ
  !      2014/05/26  TKE ͤäΤ
  !      2014/05/26  TKE ٥Τޤ޹ԤȤˤ
  !      2016/06/13  ɽ̱ư̤褦ѹ
  !      2016/07/07  Mulholland et al. 2013 Ϥˤȴ夲ɲ
  !      2017/09/04  Newman et al. 2002 ˽äͤη׻ɲ
  ! 
  !
  !== References
  !
  ! Melinda A. Kahre, James R. Murphy, and Robert M. Haberle
  ! Modeling the Martian dust cycle and surface dust
  ! reservoirs with the NASA Ames general circulation
  ! model, Journal of Geophysical Research, vol 111, E06008, 2006 
  !
  ! Newman et al. 2002
  !
  ! Mulholland et al. 2013
  !
  !== Procedures List
  !
  ! MarsDustLifting   :: Υȴ夲Ψη׻
  ! ------------      :: ------------
  !
  !== NAMELIST
  !
  ! NAMELIST#mars_dust_lifting_nml
  !

  ! ⥸塼 ; USE statements
  !

  ! ʻ
  ! Grid points settings
  !
  use gridset, only: imax, & ! ٳʻ. 
    ! Number of grid points in longitude
  &                jmax, & ! ٳʻ. 
    ! Number of grid points in latitude
  &                kmax    ! ľؿ. 
  ! Number of vertical level


  ! ̷ѥ᥿
  ! Kind type parameter
  !
  use dc_types, only: DP, &      ! ټ¿. Double precision. 
    &                 STRING     ! ʸ.       Strings. 

  ! å
  ! Message output
  !
  use dc_message, only: MessageNotify

  ! ʸ ; Declaration statements
  !
  implicit none
  private

  ! ³
  ! Public procedure
  !
  public :: MarsDustLiftingWS
  public :: MarsDustLiftingDD
  public :: MarsDustLiftingOutput
  public :: MarsDustLiftingInit

  ! ѿ
  ! Public variables
  !

  ! ѿ
  ! Private variables
  !
  logical, save :: mars_dust_lifting_inited = .false.
  ! ե饰
  ! Initialization flag
  logical, save:: threshold_drag_velocity_inited = .true.
  ! ͤ׻뤫ɤΥե饰



  character(STRING), save :: WindStressMechanism
  ! Ȥϥȴ夲ᥫ˥
  ! used wind stress lifting mechanism
  character(STRING), save :: ThresholdMechanism
  ! ٱϥȴ夲Ѥͤ
  ! used thresold mechanism with wind stress lifting
  character(STRING), save :: DustDevilMechanism
  ! Ȥϥȴ夲ᥫ˥
  ! used wind stress lifting mechanism
  character(STRING), save :: PBLTopMechanism
  ! ؾü
  real(DP) :: FrictionRate
  ! ɽ̤Ǥ໤ˤäƾ񤵤ϳŪͥ륮üΨ (Renno et al 1998 Ǥ \gamma)
  real(DP)         , save :: StressThreshold
  ! ϤǥȤ򴬤夲 (N m-2)
  ! Wind stress threshold (N m-2)
  real(DP)         , save :: StressThresholdKMH
  ! (ǥХå) ϤǥȤ򴬤夲 (N m-2)
  ! Wind stress threshold (N m-2)
  real(DP)         , save :: StressThresholdMulholland
  ! (ǥХå) ϤǥȤ򴬤夲 (N m-2)
  ! Wind stress threshold (N m-2)
  real(DP)         , save :: StressThresholdNewman
  ! (ǥХå) ϤǥȤ򴬤夲 (N m-2)
  ! Wind stress threshold (N m-2)
  real(DP)         , save :: VtangThreshold
  ! ȥǥӥǥȤ򴬤夲® (m s-1)
  ! tangant velocity threshold (m s-1)
  real(DP)         , save :: TopThreshold
  ! ήؾüɤˤ뤫
  ! Critical value at the top convective bundary layer
  real(DP)         , save :: WindStressEfficiencyFactor              
  ! Ϥˤȴ夲θΨ(m-1)
  ! Efficiency factor (m-1)
  real(DP)         , save :: DustDevilEfficiencyFactor               
  ! ȥǥӥˤȴ夲θΨ(m-1)
  ! Efficiency factor (m-1)
  real(DP)         , save :: KMHEfficiencyFactor
  ! KMH Ψ(m-1)
  ! Efficiency factor (m-1)
  real(DP)         , save :: NewmanEfficiencyFactor
  ! Newman Ψ(m-1)
  ! Efficiency factor (m-1)
  real(DP)         , save :: MulhollandEfficiencyFactor
  ! Mulholland Ψ(m-1)
  ! Efficiency factor (m-1)
  real(DP)         , save :: DDAEfficiencyFactor
  ! DDA Ψ(m-1)
  ! Efficiency factor (m-1)
  real(DP)         , save :: DTHEfficiencyFactor
  ! DTH Ψ(m-1)
  ! Efficiency factor (m-1)
  real(DP)         , save :: InterparticleCohesion
  ! Ž̥ѥ᡼ (N m^-1/2)
  ! Interparticle cohesion parameter (N m^-1/2)
  real(DP)         , save :: ThresholdDragVel
  ! ໤® (m/s)
  ! Threshold drag velocity at first (m/s)
  real(DP)         , save :: RhoDust
  ! ̩
  ! dust dencity
  real(DP)         , save :: SandDiameter
  ! Ⱦ (m)
  ! sand diameter (m)
  real(DP)         , save :: ThresholdDragVelCri
  ! ໤®٤ͤμ«Ƚ
  !
  real(DP), save:: Mu
  ! Ǵ
  ! Viscosity
  integer, save:: ItrtMax
  ! ƥ졼
  ! Number of iteration
  integer          , save :: IDMechanismTop
  ! Ѥήؾüᥫ˥Ѳѿ
  integer          , save :: IDMechanismWS
  ! Ѥϥᥫ˥Ѳѿ
  integer          , save :: IDMechanismDD
  ! Ѥȥǥӥᥫ˥Ѳѿ
  integer          , save :: IDMechanismTS
  ! ѤͤηѲѿ
  integer          , parameter :: IDMechanismTKE    = 1
  ! TKE Ѥήؾü ID
  integer          , parameter :: IDMechanismHeatflux  = 2
  ! Heatflux Ѥήؾü ID
  integer          , parameter :: IDMechanismKMH    = 1
  ! ϥᥫ˥ KMH Ѥ ID
  integer          , parameter :: IDMechanismNewman = 2
  ! ϥᥫ˥ Newman Ѥ ID
  integer          , parameter :: IDMechanismMulholland = 3
  ! ϥᥫ˥ Mulholland Ѥ ID
  integer          , parameter :: IDMechanismWSALL      = 4
  ! ǥХåѤȤϥᥫ˥ KMH  Newman ɤѤ ID
  integer          , parameter :: IDMechanismDDA        = 1
  ! ȥǥӥᥫ˥ Renno et al 1998 ͤʤ(DDA)Ѥ ID
  integer          , parameter :: IDMechanismDTH        = 2
  ! ȥǥӥᥫ˥ Greeley and Iversen 1995 ͤ륹(DTH)Ѥ ID
  integer          , parameter :: IDMechanismDDALL      = 3
  ! ǥХåѤȤƥȥǥӥᥫ˥ DDA  DTH ɤѤ ID
  !
  integer          , parameter :: IDMechanismCons       = 1
  ! ͤηϸ (Kahre et al. 2006)
  integer          , parameter :: IDMechanismCalc       = 2
  ! ͤη׻ (Newman et al. 2002)
!  logical(DP)      , save :: GustFlag
!  ! Newman et al. 2002 Ѥ줿ɽ򤹤뤫ɤΥե饰
  ! (2017/09/04  Ƴα)
  logical(DP)      , save :: DistinctThresholdFlag
  ! (ǥХå) 줾ϥѤͤ
  ! 줾̤ΤΤѤ뤫ɤΥե饰  

  character(*), parameter:: module_name = 'mars_dust_lifting'
  ! ⥸塼̾. 
  ! Module name
  character(*), parameter:: version = &
    & '$Name: dcpam5-20160612 $' // &
    & '$Id: mars_dust_lifting.f90,v 3.0 2016-07-07 15:46:00 ogihara Exp $'
  ! ⥸塼ΥС
  ! Module version


contains

  !-------------------------------------------------------------------------------------

  subroutine MarsDustLiftingWS( &
      & xy_SurfMajCompIce,                                        & ! (in)
      & xy_SurfMomFluxX, xy_SurfMomFluxY, xyr_Press, xyr_VirTemp, & ! (in)
      & xy_ThresholdDragVel,                                    & ! (in)
      & xy_MarsDustLiftingWS,                                     & ! (out)
      & xy_MDustLiftingWS1,                             & ! (out) ץ
      & xy_MDustLiftingWS2                             & ! (out) ץ
      & )
    !
    ! Х륯ˡǵ᤿, ɽ̲٤ȤäƲΥȴ夲եå
    ! ׻ޤ.

    ! ⥸塼 ; USE statements
    !

    ! ɸǡ
    ! Axes data settings
    !
    use axesset, only: &
      & y_Lat                 ! $ \varphi $ [rad.] . . Latitude

    ! 
    ! Time control
    !
    use timeset, only: &
      & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
      & TimesetClockStart, TimesetClockStop

    ! ǥХåѥ桼ƥƥ
    ! Utilities for debug
    !
    use dc_trace, only: DbgMessage, BeginSub, EndSub

    ! ʪ
    ! Physical constants settings
    !
    use constants, only: &
      & Grav, &               ! $ g $ [m s-2]. 
      ! ϲ®. 
    ! Gravitational acceleration
    & GasRDry, &
      ! $ R $ [J kg-1 K-1]. 
    ! 絤ε. 
    ! Gas constant of air
    & CpDry
    ! $ C_p $ [J kg-1 K-1]. 
    ! 絤갵Ǯ. 
    ! Specific heat of air at constant pressure

    ! ȳɹ
    ! Setting constants of snow and sea ice
    !
    use constants_snowseaice, only: &
      & CO2IceThreshold

    ! ʸ ; Declaration statements
    !
    implicit none
    real(DP), intent(in):: xy_SurfMajCompIce (0:imax-1, 1:jmax)
    ! $ M_mcs $ . ɽ̼ʬɹ (kg m-2)
    ! Surface major component ice amount (kg m-2)
    real(DP), intent(in):: xy_SurfMomFluxX (0:imax-1, 1:jmax)
    ! ư̥եå. 
    ! Eastward momentum flux
    real(DP), intent(in):: xy_SurfMomFluxY (0:imax-1, 1:jmax)
    ! ư̥եå. 
    ! Northward momentum flux
    real(DP), intent(in):: xyr_VirTemp (0:imax-1, 1:jmax, 0:kmax)
    ! $ T_v $ .  (Ⱦ٥). 
    ! Virtual temperature (half level)
    real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
    ! $ p_s $ . ɽ̵ (Ⱦ٥). 
    ! Surface pressure (half level)
    real(DP), intent(inout) :: xy_ThresholdDragVel (0:imax-1, 1:jmax)
    ! ໤®٤
    real(DP), intent(out):: xy_MarsDustLiftingWS(0:imax-1, 1:jmax)
    !Υȴ夲եå (kgm-2s-1)
    real(DP), intent(out), optional:: xy_MDustLiftingWS1(0:imax-1, 1:jmax)
    ! ǥХåѤ̤ΥˤΥȴ夲եå (kgm-2s-1)
    real(DP), intent(out), optional:: xy_MDustLiftingWS2(0:imax-1, 1:jmax)
    ! ǥХåѤ̤ΥˤΥȴ夲եå (kgm-2s-1)
    real(DP) :: MajCompIceThreshold
    ! ɽ̤Ǽʬɹ뤷Ƥ뤫
    real(DP) :: xy_MomFluxSurf (0:imax-1, 1:jmax)
    ! ɽ̱ư̥եå礭.(N m-2) 
    ! momentum flux power
    real(DP) :: xy_SurfRho (0:imax-1, 1:jmax)
    ! ɽ̩
    real(DP) :: xy_StressThreshold (0:imax-1, 1:jmax)
    ! 夲Ϥޤ
    !real(DP) :: xy_DragVel (0:imax-1, 1:jmax)
    !! ໤®


    ! ѿ
    ! Work variables
    !

    integer:: i               ! ˲ DO 롼Ѻѿ
    ! Work variables for DO loop in longitude
    integer:: j               ! ˲ DO 롼Ѻѿ
    ! Work variables for DO loop in latitude
    !    integer:: k               ! ˲ DO 롼Ѻѿ
    ! Work variables for DO loop in dimension of constituents

    ! ¹ʸ ; Executable statement
    ! ǧ
    ! Initialization check
    !
    !    if ( .not. mars_dust_lifting_inited ) call MarsDustLiftingInit
    if ( .not. mars_dust_lifting_inited ) then
      call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
    end if

    ! ץå
    ! Check arguments
    !
    if (IDMechanismWS == IDMechanismWSALL) then
      if ( .not. present(xy_MDustLiftingWS1) .or. .not. present(xy_MDustLiftingWS2)) then
        call MessageNotify( 'E', module_name, 'xy_MDustLiftingWS1 and xy_MDustLiftingWS2 have to be present.')
      end if
    end if

    !   ɽ̤ɹĥäƤȽǤͤ
    MajCompIceThreshold = CO2IceThreshold

    !   ɽ̱Ϥ礭η׻
    xy_MomFluxSurf(:,:) = sqrt( xy_SurfMomFluxX(:,:)**2 + xy_SurfMomFluxY(:,:)**2 )

    if ( IDMechanismTS == IDMechanismCalc ) then
      !ɽ̩٤η׻
      do i = 0, imax-1
        do j = 1, jmax
          xy_SurfRho(i,j) = xyr_Press(i,j,0) /(GasRDry * xyr_VirTemp(i,j,0))
        end do
      end do
      
      call ThresholdScheem( &
        & xy_SurfRho, & !(in)
        & xy_ThresholdDragVel, & !(inout)
        & xy_StressThreshold      & !(out)
        & )

      ! α (2017/09/04 )
    !  if (GustFlag)
    !  !໤®٤η׻
    !  xy_DragVel(:,:) = sqrt(xy_MomFluxSurf(:,:) / xy_SurfRho(:,:)

    !  call GustScheem( &
    !    & xy_DragVel, & !(in)
    else
      xy_StressThreshold = StressThreshold
    end if
    ! ͤȤƸͤѤ뤫 (Kahre et al. 2006), ׻뤫 (Newman et al. 2002)
    !
    !




    !write(10,*) "xyr_MomFluxX", xyr_MomFLuxX(0,1,0)
    !write(10,*) "xyr_MomFluxY", xyr_MomFLuxY(0,1,0)
    !write(10,*) "xy_MomFluxSurf=", xy_MomFluxSurf(0,1)
    !write(10,*) "StressThreshold", StressThreshold
    ! ȴ夲(KMH )
    !    do i = 0, imax-1
    !      do j = 1, jmax
    !        if(xy_MomFluxSurf(i,j) < StressThreshold) then
    !          xy_MarsDustLifting(i,j) = 0.0_DP
    !        else
    !          xy_MarsDustLifting(i,j) =                           & 
    !            & EfficiencyFactor *(( 10.0_DP)**6)                   &
    !            & * ( 2.3_DP* 0.001_DP ) * ((xy_MomFluxSurf(i,j))**2) &
    !            & * (((xy_MomFluxSurf(i,j)) - StressThreshold)       &
    !            & / StressThreshold)
    !        end if
    !      end do
    !    end do
    ! ߤɽ̤ɹͤĶȤ˴夬ʤȤƤ

    select case ( IDMechanismWS )
    case ( IDMechanismKMH )
      ! KMH ˤȴ夲
      do i = 0, imax-1
        do j = 1, jmax
          if(xy_MomFluxSurf(i,j) < xy_StressThreshold(i,j)) then
            xy_MarsDustLiftingWS(i,j) = 0.0_DP
          else 
            if (xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
              xy_MarsDustLiftingWS(i,j) = 0.0_DP
            else 
              xy_MarsDustLiftingWS(i,j) =                                                  & 
                & ((xy_MomFluxSurf(i,j))**2) * (((xy_MomFluxSurf(i,j)) - xy_StressThreshold(i,j))  &
                & / xy_StressThreshold(i,j)) ! KMH αϤι

              xy_MarsDustLiftingWS(i,j) = (2.3_DP * 0.001_DP) * xy_MarsDustLiftingWS(i,j) 
              ! ϵ¬᤿ 2.3 x 10^-3 ݤ
              xy_MarsDustLiftingWS(i,j) = WindStressEfficiencyFactor * xy_MarsDustLiftingWS(i,j)
              ! ΨҤݤ
            end if
          end if
        end do
      end do
    case ( IDMechanismNewman )


      !    do i = 0, imax-1
      !      do j = 1, jmax
      !        if((xy_MomFluxSurf(i,j)*1000.0_DP) < StressThreshold) then
      !          xy_MarsDustLifting(i,j) = 0.0_DP
      !        else
      !          xy_MarsDustLifting(i,j) =                           & 
      !            & EfficiencyFactor                                 &
      !            & * ( 2.3_DP* 0.01_DP ) * ((xy_MomFluxSurf(i,j)* 1000.0_DP)**2) &
      !            & * (((xy_MomFluxSurfX(i,j)*1000.0_DP) - StressThreshold)       &
      !            & / StressThreshold)
      !        end if
      !      end do
      !    end do


      !ɽ̩٤η׻
      do j = 1, jmax
        do i = 0, imax-1
          xy_SurfRho(i,j) = xyr_Press(i,j,0) /(GasRDry * xyr_VirTemp(i,j,0))
        end do
      end do
      ! Ϥˤȴ夲(Newman )

      do j = 1, jmax
        do i = 0, imax-1
          if (xy_MomFluxSurf(i,j) < xy_StressThreshold(i,j)) then
            xy_MarsDustLiftingWS(i,j) = 0.0_DP
          else 
            if ( xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
              xy_MarsDustLiftingWS(i,j) = 0.0_DP
            else
              xy_MarsDustLiftingWS(i,j) =                                 & 
                & ((xy_MomFluxSurf(i,j))**1.5)/(Grav*sqrt(xy_SurfRho(i,j)))   &
                & * ( 1.0_DP - sqrt(xy_StressThreshold(i,j)/xy_MomFluxSurf(i,j)))     &
                & * ( 1.0_DP + sqrt(xy_StressThreshold(i,j)/xy_MomFluxSurf(i,j)))**2 
              ! Newman αϤι

              xy_MarsDustLiftingWS(i,j) = 2.61_DP * xy_MarsDustLiftingWS(i,j) 
              ! ƶ¸᤿ 2.61ݤ

              xy_MarsDustLiftingWS(i,j) = WindStressEfficiencyFactor * xy_MarsDustLiftingWS(i,j) 
              ! ΨҤݤ
            end if
          end if
        end do
      end do
    case ( IDMechanismMulholland )

      !ɽ̩٤η׻
      do j = 1, jmax
        do i = 0, imax-1
          xy_SurfRho(i,j) = xyr_Press(i,j,0) /(GasRDry * xyr_VirTemp(i,j,0))
        end do
      end do
      ! Ϥˤȴ夲(Mulholland )

      do j = 1, jmax
        do i = 0, imax-1
          if (xy_MomFluxSurf(i,j) < xy_StressThreshold(i,j)) then
            xy_MarsDustLiftingWS(i,j) = 0.0_DP
          else 
            if ( xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
              xy_MarsDustLiftingWS(i,j) = 0.0_DP
            else
              xy_MarsDustLiftingWS(i,j) =                                 & 
                & ((xy_MomFluxSurf(i,j))**1.5)/(Grav*sqrt(xy_SurfRho(i,j)))   &
                & * ( 1.0_DP - xy_StressThreshold(i,j)/xy_MomFluxSurf(i,j))     &
                & * ( 7.0_DP + 50.0_DP * (xy_StressThreshold(i,j)/xy_MomFluxSurf(i,j)))
                ! Mulholland αϤι

              xy_MarsDustLiftingWS(i,j) = 0.25_DP * xy_MarsDustLiftingWS(i,j) 

              xy_MarsDustLiftingWS(i,j) = WindStressEfficiencyFactor * xy_MarsDustLiftingWS(i,j) 
              ! ΨҤݤ
            end if
          end if
        end do
      end do
    case ( IDMechanismWSALL )
      ! ǥХåξΥν. 
      ! KMH  MarsDustLifting  Newman  Another1MarsDustLifting 
      !  Mulholland  Another2MarsDustLifting 

      if (.not. IDMechanismTS == IDMechanismCalc .and. DistinctThresholdFlag) then
        xy_StressThreshold = StressThresholdKMH
      end if
      do j = 1, jmax
        do i = 0, imax-1
          if(xy_MomFluxSurf(i,j) < xy_StressThreshold(i,j)) then
            xy_MarsDustLiftingWS(i,j) = 0.0_DP
          else 
            if (xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
              xy_MarsDustLiftingWS(i,j) = 0.0_DP
            else 
              xy_MarsDustLiftingWS(i,j) =                                                 & 
                & ((xy_MomFluxSurf(i,j))**2) * (((xy_MomFluxSurf(i,j)) - xy_StressThreshold(i,j))  &
                & / xy_StressThreshold(i,j)) ! KMH αϤι

              xy_MarsDustLiftingWS(i,j) = (2.3_DP * 0.001_DP) * xy_MarsDustLiftingWS(i,j)
              ! ϵ¬᤿ 2.3 x 10^-3 ݤ

              xy_MarsDustLiftingWS(i,j) = KMHEfficiencyFactor * xy_MarsDustLiftingWS(i,j) 
              ! ΨҤݤ
            end if
          end if
        end do
      end do
      if (present(xy_MDustLiftingWS1)) then
        if (.not. IDMechanismTS == IDMechanismCalc .and. DistinctThresholdFlag) then
          xy_StressThreshold = StressThresholdNewman
        end if
        !ɽ̩٤η׻
        do j = 1, jmax
          do i = 0, imax-1
            xy_SurfRho(i,j) = xyr_Press(i,j,0) /(GasRDry * xyr_VirTemp(i,j,0))
          end do
        end do
        ! Ϥˤȴ夲(Newman )
        do j = 1, jmax
          do i = 0, imax-1
            if (xy_MomFluxSurf(i,j) < xy_StressThreshold(i,j)) then
              xy_MDustLiftingWS1(i,j) = 0.0_DP
            else 
              if ( xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
                xy_MDustLiftingWS1(i,j) = 0.0_DP
              else
                xy_MDustLiftingWS1(i,j) =                                 & 
                  & ((xy_MomFluxSurf(i,j))**1.5)/(Grav*sqrt(xy_SurfRho(i,j)))   &
                  & * ( 1.0_DP - sqrt(xy_StressThreshold(i,j)/xy_MomFluxSurf(i,j)))     &
                  & * ( 1.0_DP + sqrt(xy_StressThreshold(i,j)/xy_MomFluxSurf(i,j)))**2 ! Newman αϤι

                xy_MDustLiftingWS1(i,j) = 2.61_DP * xy_MDustLiftingWS1(i,j)
                ! ƶ¸᤿ 2.61ݤ

                xy_MDustLiftingWS1(i,j) = NewmanEfficiencyFactor * xy_MDustLiftingWS1(i,j)
                ! ΨҤݤ
              end if
            end if
          end do
        end do
      end if
      if (present(xy_MDustLiftingWS2)) then
        if (.not. IDMechanismTS == IDMechanismCalc .and. DistinctThresholdFlag) then
          xy_StressThreshold(i,j) = StressThresholdMulholland
        end if
        ! Ϥˤȴ夲(Mulholland )
        do j = 1, jmax
          do i = 0, imax-1
            if (xy_MomFluxSurf(i,j) < xy_StressThreshold(i,j)) then
              xy_MDustLiftingWS2(i,j) = 0.0_DP
            else 
              if ( xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
                xy_MDustLiftingWS2(i,j) = 0.0_DP
              else
                xy_MDustLiftingWS2(i,j) =                                 & 
                  & ((xy_MomFluxSurf(i,j))**1.5)/(Grav*sqrt(xy_SurfRho(i,j)))   &
                  & * ( 1.0_DP - xy_StressThreshold(i,j)/xy_MomFluxSurf(i,j))     &
                  & * ( 7.0_DP + 50.0_DP * (xy_StressThreshold(i,j)/xy_MomFluxSurf(i,j)))
                ! Mulholland αϤι

                xy_MDustLiftingWS2(i,j) = 0.25_DP * xy_MDustLiftingWS2(i,j)

                xy_MDustLiftingWS2(i,j) = MulhollandEfficiencyFactor * xy_MDustLiftingWS2(i,j)
                ! ΨҤݤ
              end if
            end if
          end do
        end do
      end if
    end select

  end subroutine MarsDustLiftingWS
  !--------------------------------------------------------------------------------------
  subroutine ThresholdScheem( &
      & xy_SurfRho, & !(in)
      & xy_ThresholdDragVel, & !(inout)
      & xy_StressThreshold      & !(out)
      & )

    ! ҥȥǡ
    ! History data output
    !
    use gtool_historyauto, only: HistoryAutoPut

    ! ʪ
    ! Physical constants settings
    !
    use timeset, only: &
      & TimeN              ! ƥå $ t $ λ. Time of step $ t $. 

    use constants, only: &
      & Grav              ! $ g $ [m s-2]. 
      ! ϲ®. 
      ! Gravitational acceleration

    implicit none
    real(DP), intent(in):: xy_SurfRho (0:imax-1, 1:jmax)
    ! $ \rho $ . ɽ絤̩ (kg m-3)
    ! Surface atmosphere density (kg m-2)
    real(DP), intent(inout):: xy_ThresholdDragVel(0:imax-1, 1:jmax)
    ! $ u_{drag}^t$. ໤®
    ! Threshold drag velocity (m/s).
    real(DP), intent(out):: xy_StressThreshold(0:imax-1, 1:jmax)
    ! $\tau^t$. 
    ! Threshold Stress (Nm^-2)
    !
    ! ѿ
    real(DP):: xy_ThresholdDragVelB(0:imax-1, 1:jmax)
    ! $ u_{drag}^t$. ໤®¸
    ! Threshold drag velocity (m/s).
    real(DP):: xy_FricReynoldsNum(0:imax-1, 1:jmax)
    ! ໤쥤Υ륺
    ! Friction Reynolds number at threshold
    real(DP):: xy_ThresholdPara(0:imax-1, 1:jmax)
    ! ໤®ͤ뷸A
    real(DP):: xy_ThresholdErr(0:imax-1,1:jmax)
    ! ໤®ͤΥƥ졼ȸκ

    logical:: xy_TSConverged(0:imax-1, 1:jmax)
    ! ໤®ͤ«ɤ?
    !
    logical:: xy_TSConvergedB(0:imax-1, 1:jmax)
    ! ໤®ͤ«ɤ?
    !
    logical:: TSConverged
    ! Ƥγʻ໤®ͤ«Ƚ
    integer:: i               ! ˲ DO 롼Ѻѿ
    ! Work variables for DO loop in longitude
    integer:: j               ! ˲ DO 롼Ѻѿ
    ! Work variables for DO loop in latitude
    integer:: itr             ! ƥ졼˲ DO 롼Ѻѿ
    ! Work variables for DO loop in itreration


    if (threshold_drag_velocity_inited) then
    ! ໤®ͤν
      xy_ThresholdDragVel = ThresholdDragVel
      threshold_drag_velocity_inited = .false.
    end if

    ! ׻ ThresholdDragVel ¸
    xy_ThresholdDragVelB = xy_ThresholdDragVel

    xy_TSConvergedB = .true.

    do itr = 1, ItrtMax
      xy_TSConverged = .false.
      do j = 1, jmax
        do i = 0, imax-1
          if (xy_TSConvergedB(i,j)) then

            xy_FricReynoldsNum(i,j) = xy_ThresholdDragVel(i,j) * SandDiameter / (Mu / xy_SurfRho(i,j))
            if (xy_FricReynoldsNum(i,j) < 0.03_DP) then
              !xy_ThresholdPara(i,j) = 0.0_DP
              call MessageNotify( 'E', module_name, 'xy_FricReynoldsNum < 0.03 is not defined.')
            elseif (0.03_DP <= xy_FricReynoldsNum(i,j) .and. xy_FricReynoldsNum(i,j) <= 0.3_DP) then
              xy_ThresholdPara(i,j) = 0.2_DP * (1.0_DP + InterparticleCohesion / (RhoDust * Grav * (SandDiameter)**2.5))**(0.5) &
                & / (1.0_DP + 2.5_DP*xy_FricReynoldsNum(i,j))**(0.5)
            elseif (0.3_DP < xy_FricReynoldsNum(i,j) .and. xy_FricReynoldsNum(i,j) <= 10.0_DP) then
              xy_ThresholdPara(i,j) = 0.129_DP * (1.0_DP + InterparticleCohesion / (RhoDust * Grav * (SandDiameter)**2.5))**(0.5) &
                & / (1.928_DP * (xy_FricReynoldsNum(i,j))**(0.092) - 1.0_DP)**(0.5)
            elseif (10 < xy_FricReynoldsNum(i,j)) then
              xy_ThresholdPara(i,j) = 0.120_DP *  (1.0_DP + InterparticleCohesion / (RhoDust * Grav * (SandDiameter)**2.5))**(0.5) &
                & * (1.0_DP - 0.0858_DP * exp(-0.0617_DP * (xy_FricReynoldsNum(i,j) - 10.0_DP)))
            end if 

            xy_ThresholdDragVel(i,j) = xy_ThresholdPara(i,j) &
              & * ( Grav * SandDiameter * (RhoDust - xy_SurfRho(i,j)) / xy_SurfRho(i,j) )**(0.5)

            xy_ThresholdErr(i,j) = xy_ThresholdDragVel(i,j) - xy_ThresholdDragVelB(i,j)

            if (xy_ThresholdErr(i,j) >= ThresholdDragVelCri) then

              xy_TSConverged(i,j) = .true.

            end if
          end if
        end do
      end do

      TSConverged = .false.
      do i = 0, imax-1
        do j = 1,jmax
          xy_TSConvergedB(i,j) = xy_TSConverged(i,j)
          TSConverged = TSConverged .or. xy_TSConverged(i,j)
        end do
      end do

      if (.not. TSConverged ) exit

      xy_ThresholdDragVelB = xy_ThresholdDragVel
    end do

    xy_StressThreshold = xy_SurfRho * (xy_ThresholdDragVel)**(2.0)

    call HistoryAutoPut( TimeN, 'TsDragVel',     xy_ThresholdDragVel(:,:))
    call HistoryAutoPut( TimeN, 'StressThreshold',    xy_StressThreshold(:,:))

  end subroutine ThresholdScheem
! ----------------------------------------

  subroutine MarsDustLiftingDD( &
      & xy_SurfMajCompIce,                                  & ! (in)
      & xyr_Press, xyz_Press, xyr_VirTemp, xy_SurfTemp,     & ! (in)
      & xyz_TurKinEne, xy_SurfHeatFlux, xyr_HeatFlux,       & ! (in)
      & xy_MarsDustLiftingDD,                               & ! (out)
      & xy_AnotherMarsDustLiftingDD                         & ! (out) ץ
      & )
    !
    ! ǮեåѤƲΥȥǥӥˤȴ夲եå
    ! ׻ޤ.

    ! ⥸塼 ; USE statements
    !

    ! ҥȥǡ
    ! History data output
    !
    use gtool_historyauto, only: HistoryAutoPut

    ! ɸǡ
    ! Axes data settings
    !
    use axesset, only: &
      & y_Lat                 ! $ \varphi $ [rad.] . . Latitude

    ! 
    ! Time control
    !
    use timeset, only: &
      & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
      & TimesetClockStart, TimesetClockStop

    ! ǥХåѥ桼ƥƥ
    ! Utilities for debug
    !
    use dc_trace, only: DbgMessage, BeginSub, EndSub

    ! ʪ
    ! Physical constants settings
    !
    use constants, only: &
      & Grav, &               ! $ g $ [m s-2]. 
      ! ϲ®. 
    ! Gravitational acceleration
    & GasRDry, &
      ! $ R $ [J kg-1 K-1]. 
    ! 絤ε. 
    ! Gas constant of air
    & CpDry
    ! $ C_p $ [J kg-1 K-1]. 
    ! 絤갵Ǯ. 
    ! Specific heat of air at constant pressure

    ! ȳɹ
    ! Setting constants of snow and sea ice
    !
    use constants_snowseaice, only: &
      & CO2IceThreshold

    ! ʸ ; Declaration statements
    !
    implicit none
    real(DP), intent(in):: xy_SurfMajCompIce (0:imax-1, 1:jmax)
    ! $ M_mcs $ . ɽ̼ʬɹ (kg m-2)
    ! Surface major component ice amount (kg m-2)
    real(DP), intent(in):: xyr_VirTemp (0:imax-1, 1:jmax, 0:kmax)
    ! $ T_v $ .  (Ⱦ٥). 
    ! Virtual temperature (half level)
    real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
    ! $ p $ .  (Ⱦ٥). 
    ! pressure (half level)
    real(DP), intent(in):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
    ! $ p $ .  (٥). 
    ! pressure 
    real(DP), intent(in):: xyz_TurKinEne (0:imax-1, 1:jmax, 1:kmax)
    ! ήưͥ륮(٥)
    ! Turberlence kinetic energy (half level)
    real(DP), intent(in):: xy_SurfHeatFlux (0:imax-1, 1:jmax)
    ! $F_h$ . ɽǮեå
    ! Surface heat flux
    real(DP), intent(in):: xyr_HeatFlux (0:imax-1, 1:jmax, 0:kmax)
    ! $F_h$ . Ǯեå(Ⱦ٥)
    ! Heat flux (half level)
    real(DP), intent(in):: xy_SurfTemp (0:imax-1, 1:jmax)
    ! $T_s$ . ɽ̲
    ! surface temperature
    real(DP), intent(out):: xy_MarsDustLiftingDD(0:imax-1, 1:jmax)
    !Υȴ夲եå (kgm-2s-1)
    real(DP), intent(out), optional:: xy_AnotherMarsDustLiftingDD(0:imax-1, 1:jmax)
    ! ǥХåѤ̤ΥˤΥȴ夲եå (kgm-2s-1)
    real(DP) :: MajCompIceThreshold
    ! ɽ̤Ǽʬɹ뤷Ƥ뤫
    real(DP) :: xy_SurfRho (0:imax-1, 1:jmax)
    ! ɽ̩
    real(DP) :: xy_Eta(0:imax-1, 1:jmax)
    ! ȥǥӥǮΨ (1 - b)
    real(DP) :: xy_EtaH(0:imax-1, 1:jmax)
    ! ȥǥӥοʿǮΨ
    real(DP) :: xy_B(0:imax-1, 1:jmax)
    ! ɽ絤ʿѲ٤ФǮǤΥȥԡʿѤ٤
    real(DP) :: xy_Vtang(0:imax-1, 1:jmax)
    ! ȥǥӥ뱲®
    real(DP) :: xy_SqrtVtang(0:imax-1, 1:jmax)
    ! ȥǥӥ뱲®
    real(DP) :: xy_DeltaP (0:imax-1,1:jmax)
    ! ȥǥӥŪʶ ( ɤȼΰϸ)
    real(DP) :: Chi
    ! R/c_p


    ! ѿ
    ! Work variables
    !

    integer:: i               ! ˲ DO 롼Ѻѿ
    ! Work variables for DO loop in longitude
    integer:: j               ! ˲ DO 롼Ѻѿ
    ! Work variables for DO loop in latitude
    integer:: k               ! ˲ DO 롼Ѻѿ
    ! Work variables for DO loop in dimension of constituents
    real(DP):: ktop(0:imax-1,1:jmax)
    ! ؾüǤֹ
    real(DP):: xy_Presstop(0:imax-1,1:jmax)
    ! ؾüΰ
    integer:: kk
    ! ؾüֹ벾ѿ


    ! ¹ʸ ; Executable statement
    ! ǧ
    ! Initialization check
    !
    !    if ( .not. mars_dust_lifting_inited ) call MarsDustLiftingInit
    if ( .not. mars_dust_lifting_inited ) then
      call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
    end if
    !   ɽ̤ɹĥäƤȽǤͤ
    MajCompIceThreshold = CO2IceThreshold

    ! chi η׻
    Chi = GasRDry/CpDry

    !   ήؤξüεǮΨ¬

    select case ( IDMechanismTop)
    case ( IDMechanismTKE)
      loop1: do j = 1, jmax
        loop2: do i = 0, imax-1
          loop3: do k = 1, kmax
            if(xyz_TurKinEne(i,j,k) <= TopThreshold) then
              ktop(i,j) = k
              exit loop3
            end if
          end do loop3
          kk = int(ktop(i,j))
          if (kk == 1) then
            xy_Presstop(i,j) = xyr_Press(i,j,0)
            xy_B(i,j) = 1.0_DP
          else
            xy_Presstop(i,j) = xyz_Press(i,j,kk-1) &
              & * (xyz_Press(i,j,kk)/xyz_Press(i,j,kk-1)) & 
              & **((xyz_TurKinEne(i,j,kk-1) - TopThreshold)/(xyz_TurKinEne(i,j,kk-1) - xyz_TurKinEne(i,j,kk) + 1.0d-11))
            xy_B(i,j) = (xyr_Press(i,j,0)**(Chi + 1.0_DP) - xy_Presstop(i,j)**(Chi + 1.0_DP)) &
              & / ((xyr_Press(i,j,0) - xy_Presstop(i,j)) * (Chi + 1.0_DP) * xyr_Press(i,j,0)**(Chi))
          end if
          xy_Eta(i,j) = 1.0_DP - xy_B(i,j)
        end do loop2
      end do loop1

    case ( IDMechanismHeatflux )
      loop4: do j = 1, jmax
        loop5: do i = 0, imax-1
          loop6: do k = 0, kmax
            if(xyr_HeatFlux(i,j,k) <= TopThreshold) then
              ktop(i,j) = k
              exit loop6
            end if
          end do loop6
          kk = int(ktop(i,j))
          if (kk == 0) then
            xy_Presstop(i,j) = xyz_Press(i,j,kk)
            xy_B(i,j) = 1.0_DP
          else
            xy_Presstop(i,j) = xyr_Press(i,j,kk-1) &
              & * (xyr_Press(i,j,kk)/xyr_Press(i,j,kk-1)) & 
              & **((xyr_HeatFlux(i,j,kk-1) - TopThreshold)/(xyr_HeatFlux(i,j,kk-1) - xyr_HeatFlux(i,j,kk) + 1.0d-11))
            xy_B(i,j) = (xyr_Press(i,j,0)**(Chi + 1.0_DP) - xy_Presstop(i,j)**(Chi + 1.0_DP)) &
              & / ((xyr_Press(i,j,0) - xy_Presstop(i,j)) * (Chi + 1.0_DP) * xyr_Press(i,j,0)**(Chi))
          end if
          xy_Eta(i,j) = 1.0_DP - xy_B(i,j)
        end do loop5
      end do loop4
    end select


    select case ( IDMechanismDD )
    case ( IDMechanismDDA )
      ! DDA ˤȴ夲
      do j = 1, jmax
        do i = 0, imax-1
          if (xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
            xy_MarsDustLiftingDD(i,j) = 0.0_DP
          else 
            xy_MarsDustLiftingDD(i,j) = xy_Eta(i,j) * max(0.0_DP, xy_SurfHeatFlux(i,j))
            xy_MarsDustLiftingDD(i,j) = DustDevilEfficiencyFactor * xy_MarsDustLiftingDD(i,j)
          end if
        end do
      end do
    case ( IDMechanismDTH )

      !ɽ̩٤η׻
      do j = 1, jmax
        do i = 0, imax-1
          xy_SurfRho(i,j) = xyr_Press(i,j,0) /(GasRDry * xyr_VirTemp(i,j,0))
        end do
      end do
      ! DTH ˤȴ夲(Newman )

      do j = 1, jmax
        do i = 0, imax-1
          if (xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
            xy_MarsDustLiftingDD(i,j) = 0.0_DP
          else 
            xy_EtaH(i,j) = (xyr_VirTemp(i,j,0) - xy_SurfTemp(i,j))/xy_SurfTemp(i,j)
            !  Newman et al 2002 ǤΤ. 
            ! Renno et al 1998 Ǥ $\frac{(T_0 - \bat{T_s})}{\bar{T_s}}$. 
            ! $T_0$ϱ濴β. $\bar{T_s}$ɽ絤ǤʿѲ. 
            xy_DeltaP(i,j) = xyr_Press(i,j,0) & 
              & * ( 1.0_DP - exp((FrictionRate * xy_Eta(i,j)) &
              & / (FrictionRate * xy_Eta(i,j) - 1.0_DP) & 
              & * ( xy_EtaH(i,j) / Chi)))

            xy_Vtang(i,j) = max(xy_DeltaP(i,j)/xy_SurfRho(i,j), 0.0_DP)
            xy_MarsDustLiftingDD(i,j) = max(0.0_DP,((xy_SurfRho(i,j) * xy_Vtang(i,j) - VtangThreshold)/Grav))
            xy_MarsDustLiftingDD(i,j) = DustDevilEfficiencyFactor * xy_MarsDustLiftingDD(i,j)
          end if
        end do
      end do

    case ( IDMechanismDDALL )
      ! ǥХåξΥν. DDA  MarsDustLifting  DTH  AnotherMarsDustLifting 
      ! DDA ˤȴ夲
      do j = 1, jmax
        do i = 0, imax-1
          if (xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
            xy_MarsDustLiftingDD(i,j) = 0.0_DP
          else 
            xy_MarsDustLiftingDD(i,j) = xy_Eta(i,j) * max(0.0_DP, xy_SurfHeatFlux(i,j))
            xy_MarsDustLiftingDD(i,j) = DDAEfficiencyFactor * xy_MarsDustLiftingDD(i,j)
          end if
        end do
      end do

      if (present(xy_AnotherMarsDustLiftingDD)) then
        !ɽ̩٤η׻
        do j = 1, jmax
          do i = 0, imax-1
            xy_SurfRho(i,j) = xyr_Press(i,j,0) /(GasRDry * xyr_VirTemp(i,j,0))
          end do
        end do
        ! DTH ˤȴ夲(Newman )
        do j = 1, jmax
          do i = 0, imax-1
            if (xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
              xy_AnotherMarsDustLiftingDD(i,j) = 0.0_DP
            else 
              xy_EtaH(i,j) = (xyr_VirTemp(i,j,0) - xy_SurfTemp(i,j))/xy_SurfTemp(i,j)
              !  Newman et al 2002 ǤΤ. 
              ! Renno et al 1998 Ǥ $\frac{(T_0 - \bat{T_s})}{\bar{T_s}}$. 
              ! $T_0$絤ǲؤβ. $\bar{T_s}$ɽ̤ǤʿѲ. 
              xy_DeltaP(i,j) = xyr_Press(i,j,0) &
                & * ( 1.0_DP - exp((FrictionRate * xy_Eta(i,j)) &
                & / (FrictionRate * xy_Eta(i,j) - 1.0_DP) &
                & * (xy_EtaH(i,j) / Chi)))

              xy_Vtang(i,j) = dmax1(xy_DeltaP(i,j)/xy_SurfRho(i,j), 0.0_DP)

              xy_SqrtVtang(i,j) = dmax1(dsqrt(xy_Vtang(i,j)), 0.0_DP)

              ! ʤ Vtang ޥʥˤʤΤǲ˥ޥʥˤʤä 0 ˤ뤳Ȥˤ

              xy_AnotherMarsDustLiftingDD(i,j) = max(0.0_DP,((xy_SurfRho(i,j) * xy_Vtang(i,j) - VtangThreshold)/Grav))
              xy_AnotherMarsDustLiftingDD(i,j) = DTHEfficiencyFactor * xy_AnotherMarsDustLiftingDD(i,j)
            end if
          end do
        end do
        call HistoryAutoPut( TimeN, 'Eta_H',     xy_EtaH(:,:))
        call HistoryAutoPut( TimeN, 'V_tang',    xy_SqrtVtang(:,:))
        call HistoryAutoPut( TimeN, 'DeltaP',    xy_DeltaP(:,:))
      end if
      call HistoryAutoPut( TimeN, 'Eta',       xy_Eta(:,:))
      call HistoryAutoPut( TimeN, 'Press_top', xy_Presstop(:,:))
      call HistoryAutoPut( TimeN, 'k_top',     ktop(:,:))
    end select

  end subroutine MarsDustLiftingDD
  !--------------------------------------------------------------------------------------

  subroutine MarsDustLiftingOutput(      &
      & xy_MarsDustLiftingDD,              & ! (in)
      & xy_MarsDustLiftingWS,              & ! (in)
      & xy_AnotherMarsDustLiftingDD,        & ! (in) ץ
      & xy_MDustLiftingWS1,        & ! (in) ץ
      & xy_MDustLiftingWS2        & ! (in) ץ
      & )
    !
    ! եå (xyr_MarsDustLifting)
    ! ˤĤƽϤԤ. 
    !
    !

    ! ⥸塼 ; USE statements
    !

    ! 
    ! Time control
    !
    use timeset, only: &
      & TimeN, &            ! ƥå $ t $ λ. Time of step $ t $.
      & TimesetClockStart, TimesetClockStop

    ! ҥȥǡ
    ! History data output
    !
    use gtool_historyauto, only: HistoryAutoPut

    ! ʸ ; Declaration statements
    !
    implicit none
    real(DP), intent(in):: xy_MarsDustLiftingDD (0:imax-1, 1:jmax)
    ! ȴ夲Ψ. 
    !  momentum flux
    real(DP), intent(in):: xy_MarsDustLiftingWS (0:imax-1, 1:jmax)
    ! ȴ夲Ψ. 
    !  momentum flux
    real(DP), intent(in), optional:: xy_AnotherMarsDustLiftingDD (0:imax-1, 1:jmax)
    ! ǥХåѥȴ夲Ψ. 
    !  momentum flux
    real(DP), intent(in), optional:: xy_MDustLiftingWS1 (0:imax-1, 1:jmax)
    ! ǥХåѥȴ夲Ψ. 
    !  momentum flux
    real(DP), intent(in), optional:: xy_MDustLiftingWS2 (0:imax-1, 1:jmax)
    ! ǥХåѥȴ夲Ψ. 
    !  momentum flux

    !    ! ϤΤκѿ
    !    real(DP):: xy_KMHDustLifting (0:imax-1, 1:jmax)
    !    real(DP):: xy_NewmanDustLifting (0:imax-1, 1:jmax)

    ! ѿ
    ! Work variables
    !
    !    integer:: i               ! ˲ DO 롼Ѻѿ
    ! Work variables for DO loop in longitude
    !    integer:: j               ! ˲ DO 롼Ѻѿ
    ! Work variables for DO loop in latitude


    ! ¹ʸ ; Executable statement
    !

    ! ׻ַ¬
    ! Start measurement of computation time
    !
    call TimesetClockStart( module_name )


    ! 
    ! Initialization
    !
    if ( .not. mars_dust_lifting_inited ) then
      call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
    end if
    !    if ( .not. mars_dust_lifting_inited ) call MarsDustLiftingInit
    !    xy_KMHDustLifting(:,:) = xy_KMHMarsDustLifting(:,:)
    !    xy_NewmanDustLifting(:,:) = xy_NewmanMarsDustLifting(:,:)

    !do i=0, imax-1
    !  do j=1, jmax
    !    write(10,*) "DustLifting=", xy_DustLifting(i,j)
    !  end do
    !end do

    ! ҥȥǡ
    ! History data output
    !
    select case ( IDMechanismWS )
    case ( IDMechanismKMH )
      call HistoryAutoPut( TimeN, 'WSDustLifting'           , xy_MarsDustLiftingWS(:,:))
    case ( IDMechanismNewman )
      call HistoryAutoPut( TimeN, 'WSDustLifting'           , xy_MarsDustLiftingWS(:,:))
    case ( IDMechanismWSALL )
      call HistoryAutoPut( TimeN, 'KMHF_d'           , xy_MarsDustLiftingWS(:,:))
      if (.not. present(xy_MDustLiftingWS1) .or. .not. present(xy_MDustLiftingWS2)) then
        call MessageNotify( 'E', module_name, 'xy_MDustLiftingWS1 and xy_MDustLiftingWS2 have to be present.')
      end if
      if (present(xy_MDustLiftingWS1)) then
        call HistoryAutoPut( TimeN, 'NewmanF_d'           , xy_MDustLiftingWS1(:,:))
      end if
      if (present(xy_MDustLiftingWS2)) then
        call HistoryAutoPut( TimeN, 'MulhollandF_d'           , xy_MDustLiftingWS2(:,:))
      end if
    end select

    select case ( IDMechanismDD )
    case ( IDMechanismDDA )
      call HistoryAutoPut( TimeN, 'DDDustLifting'           , xy_MarsDustLiftingDD(:,:))
    case ( IDMechanismDTH )
      call HistoryAutoPut( TimeN, 'DDDustLifting'           , xy_MarsDustLiftingDD(:,:))
    case ( IDMechanismDDALL )
      call HistoryAutoPut( TimeN, 'DDAF_d'           , xy_MarsDustLiftingDD(:,:))
      if (present(xy_AnotherMarsDustLiftingDD)) then
        call HistoryAutoPut( TimeN, 'DTHF_d'           , xy_AnotherMarsDustLiftingDD(:,:))
      end if
    end select
    ! ׻ַ¬
    ! Pause measurement of computation time
    !
    call TimesetClockStop( module_name )

  end subroutine MarsDustLiftingOutput

  !--------------------------------------------------------------------------------------

  subroutine MarsDustLiftingInit
    !
    ! Mars_dust_lifting ⥸塼νԤޤ. 
    ! NAMELIST#surface_flux_bulk_nml ɤ߹ߤϤμ³ǹԤޤ. 
    !
    ! "surface_flux_bulk" module is initialized. 
    ! "NAMELIST#surface_flux_bulk_nml" is loaded in this procedure. 
    !

    ! ⥸塼 ; USE statements
    !

    ! NAMELIST եϤ˴ؤ桼ƥƥ
    ! Utilities for NAMELIST file input
    !
    use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid

    ! ե
    ! File I/O support
    !
    use dc_iounit, only: FileOpen

    ! ̷ѥ᥿
    ! Kind type parameter
    !
    use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output

    ! ʸ
    ! Character handling
    !
    use dc_string, only: StoA

    ! ҥȥǡ
    ! History data output
    !
    use gtool_historyauto, only: HistoryAutoAddVariable

    ! ʸ ; Declaration statements
    !
    implicit none

    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
    ! Unit number for NAMELIST file open
    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
    ! IOSTAT of NAMELIST read

    ! NAMELIST ѿ
    ! NAMELIST group name
    !
    namelist /mars_dust_lifting_nml/ &
      & StressThreshold,             &
      & StressThresholdKMH,          &
      & StressThresholdMulholland,   &
      & StressThresholdNewman,       &
      & DistinctThresholdFlag,       &
      & VtangThreshold,              &
      & TopThreshold,                &
      & FrictionRate,                &
      & WindStressMechanism,         &
      & DustDevilMechanism,          &
      & PBLTopMechanism,             &
      & WindStressEfficiencyFactor,  &
      & DustDevilEfficiencyFactor,   &
      & KMHEfficiencyFactor,         &
      & NewmanEfficiencyFactor,      &     
      & MulhollandEfficiencyFactor,  &
      & DDAEfficiencyFactor,         &
      & DTHEfficiencyFactor,         &
      & ThresholdMechanism,          &
      & ItrtMax,                     &
      & Mu,                          &
      & InterparticleCohesion,       &
      & ThresholdDragVel,            &
      & RhoDust,                     &
      & SandDiameter,                &
      & ThresholdDragVelCri
!      & GustFlag, &
    !
    ! ǥեͤˤĤƤϽ³ "mars_dust_liftingk#MarsDustLiftingInit" 
    ! Υɤ򻲾ȤΤ. 
    !
    ! Refer to source codes in the initialization procedure
    ! "surface_flux_bulk#SurfFluxInit" for the default values. 
    !

    ! ¹ʸ ; Executable statement
    !

    if ( mars_dust_lifting_inited ) return

    ! ǥեͤ
    ! Default values settings
    !
    StressThreshold = 0.0225_DP !Kahre et al. (2006)
    ! StressThreshold = 0.020_DP !Mulholland et al. (2013)
    StressThresholdKMH = 0.0225_DP ! ǥХå. Kahre et al. (2006) Ѥ줿
    StressThresholdMulholland = 0.020_DP ! ǥХå. Mulholland et al. (2013) Ѥ줿
    StressThresholdNewman = 0.0225_DP ! ǥХå. Kahre et al. (2006) Ѥ줿
    DistinctThresholdFlag = .false.  !ǥХå. ⤷줾Υ̤ͤѤȤϤtrue ˤ
!    GustFlag = .true. !Ѥ뤫ɤ (ѤȤ true ˤ) (2017/09/04  α)
    VtangThreshold  = 15.0_DP
    TopThreshold = 0.5_DP
    FrictionRate = 0.5_DP
    WindStressMechanism = 'KMH'
    DustDevilMechanism = 'DDA'
    PBLTopMechanism = 'TKE'
    KMHEfficiencyFactor = 0.1_DP
    NewmanEfficiencyFactor = 9.0_DP * 0.000001_DP
    MulhollandEfficiencyFactor = 1.4_DP * 0.0001_DP
    WindStressEfficiencyFactor = 0.0_DP
    DDAEfficiencyFactor = 1.0_DP * 0.0000000001_DP
    DTHEfficiencyFactor = 4.0_DP * 0.0000000001_DP
    DustDevilEfficiencyFactor = 0.0_DP
    ThresholdMechanism = 'Const'  !ͤȤưͤѤ뤫 (Const), ׻뤫 (Calc) 
    ItrtMax = 10
    InterparticleCohesion = 1.0_DP * 0.0000001_DP ! Newman et al. 2002
    ThresholdDragVel = 1.30_DP ! Newman et al. 2002 Fig.1
    RhoDust = 2500.0_DP
    SandDiameter = 60.0_DP * 0.000001_DP ! Newman et al. 2002
    Mu = 1.3_DP * 0.00001_DP ! Lorenz et al. 1999

    ThresholdDragVelCri = 0.001_DP ! ʤ.



    ! NAMELIST ɤ߹
    ! NAMELIST is input
    !
    if ( trim(namelist_filename) /= '' ) then
      call FileOpen( unit_nml, &          ! (out)
        & namelist_filename, mode = 'r' ) ! (in)

      rewind( unit_nml )
      read( unit_nml, &                ! (in)
        & nml = mars_dust_lifting_nml, &  ! (out)
        & iostat = iostat_nml )        ! (out)
      close( unit_nml )

      call NmlutilMsg( iostat_nml, module_name ) ! (in)
    end if

    if ( WindStressMechanism == 'KMH' ) then
      IDMechanismWS = IDMechanismKMH
      ! ҥȥǡϤΤΤѿϿ
      ! Register of variables for history data output
      !
      call HistoryAutoAddVariable( 'WSDustLifting', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'Martian dust lifting rate by wind stress ', 'kg m-2 s-1' )
      ! Ψҥǥե( KMH ξ )
      if ( WindStressEfficiencyFactor == 0.0_DP ) then
        WindStressEfficiencyFactor = KMHEfficiencyFactor
      end if
    else if ( WindStressMechanism == 'Newman' ) then
      IDMechanismWS = IDMechanismNewman
      ! ҥȥǡϤΤΤؤѿϿ
      ! Register of variables for history data output
      !
      call HistoryAutoAddVariable( 'WSDustLifting', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'Martian dust lifting rate by wind stress ', 'kg m-2 s-1' )
      ! Ψҥǥե( Newman ξ )
      if ( WindStressEfficiencyFactor == 0.0_DP ) then
        WindStressEfficiencyFactor = NewmanEfficiencyFactor
      end if
    else if ( WindStressMechanism == 'Mulholland' ) then
      IDMechanismWS = IDMechanismMulholland
      ! ҥȥǡϤΤΤؤѿϿ
      ! Register of variables for history data output
      !
      call HistoryAutoAddVariable( 'WSDustLifting', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'Martian dust lifting rate by wind stress ', 'kg m-2 s-1' )
      ! Ψҥǥե( Newman ξ )
      if ( WindStressEfficiencyFactor == 0.0_DP ) then
        WindStressEfficiencyFactor = MulhollandEfficiencyFactor
        StressThreshold = 0.020_DP 
      end if
    else if ( WindStressMechanism == 'ALL' ) then
      IDMechanismWS = IDMechanismWSALL
      ! ҥȥǡϤΤΤؤѿϿ
      ! Register of variables for history data output
      !
      call HistoryAutoAddVariable( 'KMHF_d', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'Martian dust lifting rate by wind stress ', 'kg m-2 s-1' )
      call HistoryAutoAddVariable( 'NewmanF_d', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'Martian dust lifting rate by wind stress ', 'kg m-2 s-1' )
      call HistoryAutoAddVariable( 'MulhollandF_d', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'Martian dust lifting rate by wind stress ', 'kg m-2 s-1' )
    else
      call MessageNotify( 'E', module_name, &
        & 'Wind stress lifting mechanism of %c is not supported.', c1 = trim( WindStressMechanism ) )
    end if

    if ( DustDevilMechanism == 'DDA' ) then
      IDMechanismDD = IDMechanismDDA
      ! ҥȥǡϤΤΤѿϿ
      ! Register of variables for history data output
      !
      call HistoryAutoAddVariable( 'DDDustLifting', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'Martian dust lifting rate by dust devil ', 'kg m-2 s-1' )
      ! Ψҥǥե( KMH ξ )
      if ( DustDevilEfficiencyFactor == 0.0_DP ) then
        DustDevilEfficiencyFactor = DDAEfficiencyFactor
      end if
    else if ( DustDevilMechanism == 'DTH' ) then
      IDMechanismDD = IDMechanismDTH
      ! ҥȥǡϤΤΤؤѿϿ
      ! Register of variables for history data output
      !
      call HistoryAutoAddVariable( 'DDDustLifting', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'Martian dust lifting rate by dust devil ', 'kg m-2 s-1' )
      ! Ψҥǥե( Newman ξ )
      if ( DustDevilEfficiencyFactor == 0.0_DP ) then
        DustDevilEfficiencyFactor = DTHEfficiencyFactor
      end if
    else if ( DustDevilMechanism == 'ALL' ) then
      IDMechanismDD = IDMechanismDDALL
      ! ҥȥǡϤΤΤؤѿϿ
      ! Register of variables for history data output
      !
      call HistoryAutoAddVariable( 'DDAF_d', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'Martian dust lifting rate by dust devil ', 'kg m-2 s-1' )
      call HistoryAutoAddVariable( 'DTHF_d', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'Martian dust lifting rate by dust devil ', 'kg m-2 s-1' )
      call HistoryAutoAddVariable( 'Eta', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'convective thermodynamic effciency ', ' ')
      call HistoryAutoAddVariable( 'Eta_H', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'horizontal convective thermodynamic effciency ', ' ')
      call HistoryAutoAddVariable( 'V_tang', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'tangential velocity ', 'm s-1')
      call HistoryAutoAddVariable( 'Press_top', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'top press of boundary layor ', 'Pa')
      call HistoryAutoAddVariable( 'DeltaP', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'delta P of convective vorticity ', 'Pa')
      call HistoryAutoAddVariable( 'k_top', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'the number of top of boundary layor ', ' ')
    else
      call MessageNotify( 'E', module_name, &
        & 'Dust devil lifting mechanism of %c is not supported.', c1 = trim( WindStressMechanism ) )
    end if

    if ( PBLTopMechanism == 'TKE' ) then
      IDMechanismTop = IDMechanismTKE
    else if ( PBLTopMechanism == 'Heatflux' ) then
      IDMechanismTop = IDMechanismHeatFlux
    else
      call MessageNotify( 'E', module_name, &
        & 'PBL mechanism of %c is not supported.', c1 = trim( PBLTopMechanism ) )
    end if

    if (ThresholdMechanism == 'Const' ) then
      IDMechanismTS = IDMechanismCons
    else if ( ThresholdMechanism == 'Calc' ) then
      IDMechanismTS = IDMechanismCalc
      ! ҥȥǡϤΤΤؤѿϿ
      ! Register of variables for history data output
      !
      call HistoryAutoAddVariable( 'StressThreshold', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'Marthan dust lifting threshold stress', 'kg m-2 s-1' )
      call HistoryAutoAddVariable( 'TsDragVel', &
        & (/ 'lon ', 'lat ', 'time' /), &
        & 'threshold drag velocity of marthan dust lifting', 'm s-1' )
    else
      call MessageNotify( 'E', module_name, &
        & 'Threshold mechanism of %c is not supported.', c1 = trim( ThresholdMechanism ) )
    end if

    !  ; Print
    !
    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )

    call MessageNotify( 'M', module_name, '  StressThreshold   = %f', d = (/ StressThreshold   /) )
    call MessageNotify( 'M', module_name, '  VtangThreshold   = %f', d = (/ VtangThreshold   /) )
    call MessageNotify( 'M', module_name, '  TopThreshold   = %f', d = (/ TopThreshold   /) )
    call MessageNotify( 'M', module_name, '  FrictionRate   = %f', d = (/ FrictionRate   /) )
    call MessageNotify( 'M', module_name, '  WindStressEfficiencyFactor   = %f', d = (/ WindStressEfficiencyFactor   /) )
    call MessageNotify( 'M', module_name, '  DustDevilEfficiencyFactor   = %f', d = (/ DustDevilEfficiencyFactor   /) )
    call MessageNotify( 'M', module_name, '  WindStressMechanism = %c', c1 = trim( WindStressMechanism ) )
    call MessageNotify( 'M', module_name, '  PBLTopMechanism = %c', c1 = trim( PBLTopMechanism ) )
    call MessageNotify( 'M', module_name, '  DustDevilMechanism = %c', c1 = trim( DustDevilMechanism ) )
    call MessageNotify( 'M', module_name, '  KMHEfficiencyFactor  = %f', d = (/ KMHEfficiencyFactor  /) )
    call MessageNotify( 'M', module_name, '  NewmanEfficiencyFactor  = %f', d = (/ NewmanEfficiencyFactor  /) )
    call MessageNotify( 'M', module_name, '  MulhollandEfficiencyFactor  = %f', d = (/ MulhollandEfficiencyFactor  /) )
    call MessageNotify( 'M', module_name, '  DDAEfficiencyFactor  = %f', d = (/ DDAEfficiencyFactor  /) )
    call MessageNotify( 'M', module_name, '  DTHEfficiencyFactor  = %f', d = (/ DTHEfficiencyFactor  /) )
    call MessageNotify( 'M', module_name, '  ThresholdMechanism  = %c', c1 = trim( ThresholdMechanism ) )
    call MessageNotify( 'M', module_name, '  ItrtMax  = %i', i = (/ ItrtMax  /) )
    call MessageNotify( 'M', module_name, '  InterparticleCohesion  = %f', d = (/ InterparticleCohesion  /) )
    call MessageNotify( 'M', module_name, '  ThresholdDragVel  = %f', d = (/ ThresholdDragVel  /) )
    call MessageNotify( 'M', module_name, '  RhoDust  = %f', d = (/ RhoDust  /) )
    call MessageNotify( 'M', module_name, '  SandDiameter  = %f', d = (/ SandDiameter  /) )
    call MessageNotify( 'M', module_name, '  Mu  = %f', d = (/ Mu /) )
    call MessageNotify( 'M', module_name, '  ThresholdDragVelCri  = %f', d = (/ ThresholdDragVelCri  /) )
    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )

    mars_dust_lifting_inited = .true.

  end subroutine MarsDustLiftingInit

  !-------------------------------------------------------------------

end module mars_dust_lifting
